int xAxis, yAxis;
int  x = 0;
int  y = 0;
int speedMult = 1;

int motorA = 0;
int motorB = 0;
 
void setup() {
//bluetooth
Serial.begin(9600);
//pins for motor shield
pinMode(11, OUTPUT);
pinMode(10, OUTPUT);
pinMode(9, OUTPUT);
pinMode(6, OUTPUT);
pinMode(5, OUTPUT);
pinMode(3, OUTPUT);
}
 
void loop() {
  //when the joystick is not being used and is centred joystick there is no signal to the motors
  xAxis = 50;
  yAxis = 50;
  
  // recieve data sent from android app
  while (Serial.available() >= 3) {
    x = Serial.read();
    delay(2);
    y = Serial.read();
    delay(2);
    speedMult = Serial.read();
  }
  delay(2);

  // map data sent from app to values useable for the motors
  if (x > 4 & x < 96) {
    xAxis = map(x, 94, 4, 100, 0);
  }
  if (y > 4 & y < 96) {
    yAxis = map(y, 94, 4, 0, 100);
  }
  if (speedMult > 10 & speedMult < 24) {
    speedMult = (speedMult/10);
    }

  // setting the yAxis to control forward and backward
  if (yAxis < 45) {
    // motorA backward
    digitalWrite(10, HIGH);
    digitalWrite(11, LOW);
    // motorB backward
    digitalWrite(9, HIGH);
    digitalWrite(6, LOW);
    // maps the declining yAxis readings for going backward from 45 - 0 into 0 - 100 for increasing the motor speed
    motorA = map(yAxis, 45, 0, 0, 100);
    motorB = map(yAxis, 45, 0, 0, 100);
  }
  else if (yAxis > 55) {
    // motorA forward
    digitalWrite(10, LOW);
    digitalWrite(11, HIGH);
    // motorB forward
    digitalWrite(9, LOW);
    digitalWrite(6, HIGH);
    // maps the increasing yAxis readings for going forward from 55 - 100 into 0 - 100 value for increasing the motor speed
    motorA = map(yAxis, 55, 100, 0, 100);
    motorB = map(yAxis, 55, 100, 0, 100);
  }
 
  else {
    // when joystick is static, no value is sent
    motorA = 0;
    motorB = 0;
  }

  // setting xAxis to control left and right 
  if (xAxis < 45) {
    // maps the declining yAxis readings from 45 - 0 into increasing 0 - 100 
    int xMap = map(xAxis, 45, 0, 0, 100);
    // decrease left motor speed, increase right motor speed - TURN LEFT
    motorA = motorA - xMap;
    motorB = motorB + xMap;
    // cap range from 0 - 100
    if (motorA < 0) {
      motorA = 0;
    }
    if (motorB > 100) {
      motorB = 100;
    }
  }
  if (xAxis > 55) {
    // maps the increasing yAxis readings from 55 - 100 into 0 - 100
    int xMap = map(xAxis, 55, 100, 0, 100);
    // decrease right motor speed, increase left motor speed - TURN RIGHT
    motorA = motorA + xMap;
    motorB = motorB - xMap;
    // cap range from 0 to 100
    if (motorA > 255) {
      motorA = 255;
    }
    if (motorB < 0) {
      motorB = 0;
    }
  } 

  analogWrite(5, motorA * speedMult); // PWM to motorA
  analogWrite(3, motorB * speedMult); // PWMto motor B
}
